//***************************************************************
// 			1    LED							*
//***************************************************************

//    3-  
//      

//     
// ,      CPU
//      

//CPU Atmega8
// RC  2
// CKSEL=0010, SUT=10
// WinAVR20090313
//   1096


#define F_CPU 2000000L //  

// --------------  ----------------------------------
#include <avr/io.h>			//   
#include <avr/pgmspace.h>	//     flash
#include <util/delay.h>		//  
#include <avr/wdt.h>		//   
#include <avr/interrupt.h>	//  

// --------------  LED -----------------------------
#define maskb 0b11111111 //    /
#define B PB0 //  LED    /
#define G PB1
#define C PB2
#define H PB3
#define D PB4
#define E PB5
#define A PB6
#define F PB7


// --------------  ----------------------------------
#define rb(x) (pgm_read_byte(&x))	//     flash

#define PORT_SEG PORTB	//  
#define DDR_SEG DDRB	//   /

#define PORT_LED PORTD	//   LED 
#define DDR_LED DDRD	//   /

#define LED0 0	//   
#define LED1 1	//   
#define LED2 2	//   


// ------------    -------------------------
//    0  9  ""  LED   
//  a -> 0,  h -> 7  (=1  , =0  )
//const unsigned char code_sym[11] PROGMEM={0xC0,0xF9,0xA4,0xB0,0x99,
//										  0x92,0x82,0xF8,0x80,0x90,0xFF};

//    LED   
const unsigned char code_sym[11] PROGMEM={0x3F,0x06,0x5B,0x4F,0x66,
										  0x6D,0x7D,0x07,0x7F,0x6F,0x00};


const int Um=5000; 	//     100
long int NV;		//  
unsigned char Dig[3];	//     
volatile unsigned int t;		//   
volatile unsigned char pos,point;	//       



//  
int mesuare_U(void); void mem_value(void);
void LED_OFF(void); void LED_ON(unsigned char code);


// --------------   ----------------------------
ISR (BADISR_vect)	//    
{
reti();
}

// -------------------------------------------------------------
ISR (TIMER0_OVF_vect)	//     0
{ unsigned char numer;

    TCNT0=190;	//     2

	//      
	LED_OFF();
	_delay_us(400);	// ,  

	if (pos==1) {point=0;}	//    
	else {point=1;}

	//   
	switch (pos) //   
	{ case 0: {PORT_LED&=~(1<<LED0);} break;
	  case 1: {PORT_LED&=~(1<<LED1);} break;
	  case 2: {PORT_LED&=~(1<<LED2);} break;
	}

	numer=Dig[pos];//     
	LED_ON(rb(code_sym[numer]));


	if (pos==2) {pos=0;} //  
		else {pos++;}
	t++;	//  


}


//****************   ****************************
int main(void)
{
unsigned char i;//  
unsigned int NA;//  


ACSR=0x80;	//  

//  
ADMUX=0xC2;	//  2,   2,56  
ADCSR=0x84;	//  , =16 (125),   


//  
DDR_SEG=maskb;	//   
DDR_LED=( (1<<LED2)|(1<<LED1)|(1<<LED0) );	//   

PORT_SEG&=~maskb;	//  
PORT_LED&=~( (1<<LED2)|(1<<LED1)|(1<<LED0) );


//   
cli();
wdt_enable(WDTO_2S);

//  0
TCCR0=0x03;	// =64, =8,192
TIMSK=0x01;	//     0
sei();

//  
t=0; pos=0;

// ************   **********************************
while(1)
 {
 asm("wdr");	//   


// ~~~~~~~~   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	ADMUX=0xC2;	//  1- 
	//  16  
	NA=0;
	for (i=0;i<16;i++)	{NA+=mesuare_U();}
	NA/=16;	//   

	//      
	NV=(long int) NA*Um;
	NV>>=10; //   1024

	//   
	mem_value();

	asm("wdr");

// ~~~~~~~~  0,5 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	t=0;
	while(t<250);

 }
return 0;
}


// ********  ********************************************
//   
int mesuare_U(void)
{
	ADCSR|=(1<<ADSC);	//  
	while (bit_is_set(ADCSR,ADSC)); //      
	return (ADCL+(ADCH<<8));
}

//----------------------------------------------------------------
//   
void mem_value(void)
{ unsigned char R;	//   
	R=NV%10;
	NV-=R;
	if (R>5) {NV+=10;}	//   

	//     
	NV/=10;
	R=(NV%10);
	NV-=R;
	Dig[0]=R;

	//     
	NV/=10;
	R=(NV%10);
	NV-=R;
	Dig[1]=R;

	//     
	NV/=10;
	if (NV==0) {Dig[2]=10;} //     
	else {Dig[2]=NV;}
}


//-----------------------------------------------------------------
void LED_OFF(void) //     
{
//PORT_LED&=~( (1<<LED0)|(1<<LED1)|(1<<LED2) ); //  
//PORT_SEG|=maskb; //        
				 //      
				 //    
PORT_LED|=( (1<<LED0)|(1<<LED1)|(1<<LED2) );
PORT_SEG=0b00000000;

}

//-----------------------------------------------------------------
void LED_ON(unsigned char code) //      
{
if (code&(1<<0)) {PORT_SEG|=(1<<A);}
	else {PORT_SEG&=~(1<<A);}
if (code&(1<<1)) {PORT_SEG|=(1<<B);}
	else {PORT_SEG&=~(1<<B);}
if (code&(1<<2)) {PORT_SEG|=(1<<C);}
	else {PORT_SEG&=~(1<<C);}
if (code&(1<<3)) {PORT_SEG|=(1<<D);}
	else {PORT_SEG&=~(1<<D);}
if (code&(1<<4)) {PORT_SEG|=(1<<E);}
	else {PORT_SEG&=~(1<<E);}
if (code&(1<<5)) {PORT_SEG|=(1<<F);}
	else {PORT_SEG&=~(1<<F);}
if (code&(1<<6)) {PORT_SEG|=(1<<G);}
	else {PORT_SEG&=~(1<<G);}

if (point==1) {PORT_SEG&=~(1<<H);}	//   
else {PORT_SEG|=(1<<H);} //   
}
